<?php

/**
 * pnphpbb2pnforum v1.0 (c) frank.schummertz@landseer-stuttgart.de
 *
 * You are using this on your own risk!!!
 *
 * Be sure to backup your database before running this script.
 *
 */

include "includes/pnAPI.php";
include "modules/pnForum/common.php";

global $dbconn, $pntable, $prefix;

pnInit();

if (!pnSecAuthAction(0, 'pnForum::', "::", ACCESS_ADMIN)) { 
    pnRedirect("index.php");
}

pnModDBInfoLoad('pnForum');  
$dbconn =& pnDBGetConn(true);
$pntable =& pnDBGetTables();

$prefix = pnConfigGetVar('prefix') . '_phpbb';

echo getnumberofposts() . " postings to convert, starting in<br />";
for($i=10;$i>=0;$i--) {
    sleep(1);
    echo "$i<br /> ";
    flush();
}

$time_start = microtime_float();
truncate_destination_tables();
convert_categories();
convert_forums();
convert_topics();
convert_posts();
convert_posts_extra();   // possibly time consuming !!
convert_posts_text();
convert_topics_extra();  // possibly time consuming !!
convert_users();
convert_users_extra();   // possibly time consuming !!
convert_ranks();
convert_topics_watch();
$time_end = microtime_float();
$time = $time_end - $time_start;

echo "<br /><br />pnphpbb2 to pnForum conversion done in $time seconds";

exit();

/**
 * categories
 *
 */
function convert_categories()
{
    global $dbconn, $pntable, $prefix;
    echo "Categories : ";
    flush();
    // categories
    $fromcattable = $prefix . "_categories";
    $tocattable   = $pntable['pnforum_categories'];
    $tocatcolumn  = &$pntable['pnforum_categories_column']; 
    $sql = "DELETE FROM $tocattable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }

    $sql = "INSERT INTO $tocattable (
                $tocatcolumn[cat_id], 
                $tocatcolumn[cat_title], 
                $tocatcolumn[cat_order])
            SELECT " . $fromcattable . ".cat_id, 
                   " . $fromcattable . ".cat_title, 
                   " . $fromcattable . ".cat_order 
            FROM $fromcattable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    echo $dbconn->Affected_Rows() . " categories converted<br />";
    flush();
    return;
}

/**
 * forums
 *
 */
function convert_forums()
{
    global $dbconn, $pntable, $prefix;
    echo "Forums : ";
    flush();
    $fromforumstable = $prefix . "_forums";
    $toforumstable   = $pntable['pnforum_forums'];
    $toforumscolumn  = &$pntable['pnforum_forums_column']; 
    $sql = "DELETE FROM $toforumstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    $sql = "INSERT INTO $toforumstable (
                $toforumscolumn[forum_id], 
                $toforumscolumn[cat_id], 
                $toforumscolumn[forum_name], 
                $toforumscolumn[forum_desc], 
                $toforumscolumn[forum_order], 
                $toforumscolumn[forum_posts], 
                $toforumscolumn[forum_topics], 
                $toforumscolumn[forum_last_post_id])                             
            SELECT " . $fromforumstable . ".forum_id, 
                   " . $fromforumstable . ".cat_id, 
                   " . $fromforumstable . ".forum_name, 
                   " . $fromforumstable . ".forum_desc, 
                   " . $fromforumstable . ".forum_order, 
                   " . $fromforumstable . ".forum_posts, 
                   " . $fromforumstable . ".forum_topics, 
                   " . $fromforumstable . ".forum_last_post_id
            FROM $fromforumstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    echo $dbconn->Affected_Rows() . " forums converted<br />";
    flush();
    return;
}

/**
 * Topics
 *
 */
function convert_topics()
{
    global $dbconn, $pntable, $prefix;
    echo "Topics : ";
    flush();
    $fromtopicstable = $prefix . "_topics";
    $totopicstable   = $pntable['pnforum_topics'];
    $totopicscolumn  = &$pntable['pnforum_topics_column']; 
    $sql = "DELETE FROM $totopicstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    $sql = "INSERT INTO $totopicstable (
                $totopicscolumn[topic_id], 
                $totopicscolumn[forum_id], 
                $totopicscolumn[topic_title], 
                $totopicscolumn[topic_poster], 
                $totopicscolumn[topic_views], 
                $totopicscolumn[topic_replies], 
                $totopicscolumn[topic_status],
                $totopicscolumn[topic_last_post_id] ) 
            SELECT " . $fromtopicstable .".topic_id, 
                   " . $fromtopicstable .".forum_id, 
                   " . $fromtopicstable .".topic_title, 
                   " . $fromtopicstable .".topic_poster, 
                   " . $fromtopicstable .".topic_views, 
                   " . $fromtopicstable .".topic_replies, 
                   " . $fromtopicstable .".topic_status,
                   " . $fromtopicstable .".topic_last_post_id
            FROM $fromtopicstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    echo $dbconn->Affected_Rows() . " topics converted<br />";
    flush();
    return;
}

/**
 * topic_extra
 *
 */
function convert_topics_extra()
{
    global $dbconn, $pntable, $prefix;
    // copy topic_time, this needs our attention
    $fromtopicstable = $prefix . "_topics";
    $totopicstable   = $pntable['pnforum_topics'];
    $totopicscolumn  = &$pntable['pnforum_topics_column']; 
    $topoststable   = $pntable['pnforum_posts'];
    $topostscolumn  = &$pntable['pnforum_posts_column']; 

    $sql = "SELECT " . $fromtopicstable . ".topic_id,
                   " . $fromtopicstable . ".topic_time 
            FROM $fromtopicstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    $timearray = array();
    while(!$result->EOF) {
        $row = $result->GetRowAssoc(false);
        $timearray[$row['topic_id']] = date("Y-m-d H:i", $row['topic_time']);
        $result->MoveNext();
    }
    $result->Close();
    
    $topictimecount = 0;
    foreach($timearray as $topic_id=>$topic_time) {
        $sql2 = "UPDATE $totopicstable
                 SET $totopicscolumn[topic_time] = '$topic_time'
                 WHERE $totopicscolumn[topic_id] = $topic_id";
        $result2 = $dbconn->Execute($sql2);
        if ($dbconn->ErrorNo() != 0) {
        	die($dbconn->ErrorMsg() . " : $sql2");
        }
        $topictimecount++;
    }

/*
    $sql = "SELECT $totopicscolumn[topic_id] 
            FROM $totopicstable
            ORDER BY $totopicscolumn[topic_id]";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    $topictimecount = 0;
    while(!$result->EOF) {
        list($topic_id) = $result->fields;
        $sql2 = "SELECT $topostscolumn[post_time]
                 FROM $topoststable
                 WHERE $topostscolumn[topic_id]='".(int)pnVarPrepForStore($topic_id) . "'
                 ORDER BY $topostscolumn[post_time] DESC LIMIT 1";

        $result2 = $dbconn->Execute($sql2);
        if ($dbconn->ErrorNo() != 0) {
            die($dbconn->ErrorMsg() . " : $sql2");
        }
        list($post_time) = $result2->fields;
        $result2->Close();

        $sql3 = "UPDATE $totopicstable
                 SET $totopicscolumn[topic_time] ='" .
                 pnVarPrepForStore($post_time) . "'
                 WHERE $totopicscolumn[topic_id]='".(int)pnVarPrepForStore($topic_id) . "'";
        $result3 = $dbconn->Execute($sql3);
        if ($dbconn->ErrorNo() != 0) {
            die($dbconn->ErrorMsg() . " : $sql2");
        }
        $result3->Close();
        $result->MoveNext();
        $topictimecount++;
    }
    $result->Close();
*/    
    echo "$topictimecount topic times converted<br />";
    flush();
    
    $sql2 = "UPDATE $totopicstable
             SET $totopicscolumn[topic_poster] = 1
            WHERE $totopicscolumn[topic_poster]=0";
    $result2 = $dbconn->Execute($sql2);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql2");
    }
    echo "Anonymous User changed to userid 1 in " . $dbconn->Affected_Rows() . " topics<br />";
    flush();
    return;
}

/**
 * posts
 *
 */
function convert_posts()
{
    global $dbconn, $pntable, $prefix;
    echo "Postings : ";
    flush();
    $frompoststable = $prefix . "_posts";
    $topoststable   = $pntable['pnforum_posts'];
    $topostscolumn  = &$pntable['pnforum_posts_column']; 
    $sql = "DELETE FROM $topoststable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    $sql = "INSERT INTO $topoststable (
                $topostscolumn[post_id], 
                $topostscolumn[topic_id], 
                $topostscolumn[forum_id], 
                $topostscolumn[poster_id])                             
            SELECT " . $frompoststable . ".post_id, 
                   " . $frompoststable . ".topic_id, 
                   " . $frompoststable . ".forum_id, 
                   " . $frompoststable . ".poster_id 
            FROM $frompoststable";
    
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    echo $dbconn->Affected_Rows() . " postings converted<br />";
    flush();
    return;
}

/**
 * posts_extra
 *
 */
function convert_posts_extra()
{
    global $dbconn, $pntable, $prefix;
    $frompoststable = $prefix . "_posts";
    $topoststable   = $pntable['pnforum_posts'];
    $topostscolumn  = &$pntable['pnforum_posts_column']; 

    $sql = "SELECT " . $frompoststable . ".post_id,
                   " . $frompoststable . ".post_time, 
                   " . $frompoststable . ".poster_ip 
            FROM $frompoststable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    $postarray = array();
    while(!$result->EOF) {
        $row = $result->GetRowAssoc(false);
        // decode IP
    	$hexipbang = explode('.', chunk_split($row['poster_ip'], 2, '.'));
        $realip = hexdec($hexipbang[0]). '.' . hexdec($hexipbang[1]) . '.' . hexdec($hexipbang[2]) . '.' . hexdec($hexipbang[3]);
        $postarray[$row['post_id']] = array( 'post_time' => date("Y-m-d H:i", $row['post_time']),
                                             'poster_ip'   => $realip);
        $result->MoveNext();
    }
    $result->Close();
    
    $postcount = 0;
    foreach($postarray as $post_id=>$postentry) {
        $sql2 = "UPDATE $topoststable
                 SET $topostscolumn[post_time] = '" . $postentry['post_time'] . "',
                     $topostscolumn[poster_ip] = '" . $postentry['poster_ip'] . "'
                WHERE $topostscolumn[post_id]=$post_id";
        $result2 = $dbconn->Execute($sql2);
        if ($dbconn->ErrorNo() != 0) {
        	die($dbconn->ErrorMsg() . " : $sql2");
        }
        $postcount++;
    }
    echo "$postcount post times converted<br />";
    flush();
    
    $sql2 = "UPDATE $topoststable
             SET $topostscolumn[poster_id] = 1
            WHERE $topostscolumn[poster_id]=0";
    $result2 = $dbconn->Execute($sql2);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql2");
    }
    echo "Anonymous User changed to userid 1 in " . $dbconn->Affected_Rows() . " postings<br />";
    flush();
    return;
}

/**
 * posts test
 *
 */
function convert_posts_text()
{
    global $dbconn, $pntable, $prefix;
    // the $perCall variable determines how many rows to
    // return per database call.  The bigger the number
    // the more RAM that will need to be available. This is
    // just a precaution for anybody who has a huge database
    // but may only have an 8MB limit in their PHP setup.
    $perCall = 2000;
    echo "Post texts : ";
    flush();
    $frompoststable = $prefix . "_posts";
    $frompoststexttable = $prefix . "_posts_text";
    $topoststexttable   = $pntable['pnforum_posts_text'];
    $topoststextcolumn  = &$pntable['pnforum_posts_text_column']; 
    $sql = "DELETE FROM $topoststexttable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }

    $sql = "SELECT count(post_id)
            FROM $frompoststexttable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    list($count) = $result->fields;
    $result->Close();
    
    if ($count < $perCall) {
        $limit = $count;
    } else {
        $limit = $perCall;
    }
    $start = 0;
    $finalCount = 0;
    do {
        $sql = "SELECT pt.post_id,
                       pt.post_text,
                       p.enable_sig
                FROM $frompoststexttable AS pt
                LEFT JOIN $frompoststable AS p
                ON pt.post_id=p.post_id";
        $result = $dbconn->SelectLimit($sql,$limit,$start);
        while (!$result->EOF) {
            list($post_id, $post_text, $enableSig) = $result->fields;
            $sql2 = "INSERT INTO $topoststexttable
                     SET $topoststextcolumn[post_id]='" . (int)$post_id . "',
                         $topoststextcolumn[post_text]='" . pnVarPrepForStore(cleanBBcode($post_text,(bool)$enableSig)) . "'";
            $result2 = $dbconn->Execute($sql2);
            if ($dbconn->ErrorNo() != 0) {
                die($dbconn->ErrorMsg() . " : $sql");
            }
            $finalCount += $dbconn->Affected_Rows();
            $result2->Close();
            unset($post_id, $post_text, $enableSig);
            $result->MoveNext();
        }
        $count -= $limit;
        $start += $limit;
        if ($count < $limit) {
            $limit = $count;
        }
        $result->Close();
    } while ($count > 0);

    echo $finalCount . " post texts converted<br />";
    flush();
}

function cleanBBcode($post_text, $enableSig)
{
    // bold
	$post_text = preg_replace("/\[b:(\w){10}\]/si","[b]", $post_text);
    $post_text = preg_replace("/\[\/b:(\w){10}\]/si", "[/b]", $post_text);
    // italics
	$post_text = preg_replace("/\[i:(\w){10}\]/si","[i]", $post_text);
    $post_text = preg_replace("/\[\/i:(\w){10}\]/si", "[/i]", $post_text);
    // underline
	$post_text = preg_replace("/\[u:(\w){10}\]/si","[u]", $post_text);
    $post_text = preg_replace("/\[\/u:(\w){10}\]/si", "[/u]", $post_text);
    // image
	$post_text = preg_replace("/\[img:(\w){10}\]/si","[img]", $post_text);
    $post_text = preg_replace("/\[\/img:(\w){10}\]/si", "[/img]", $post_text);
    // quote
	$post_text = preg_replace("/\[quote:(\w){10}=\"(.*?)\"\]/si","[quote=\\2]", $post_text);
    $post_text = preg_replace("/\[\/quote:(\w){10}\]/si", "[/quote]", $post_text);
    // size
	$post_text = preg_replace_callback("/\[size=(.*?):(\w){10}\]/si","determineSize", $post_text);
    $post_text = preg_replace("/\[\/size:(\w){10}\]/si", "[/size]", $post_text);
    // color
	$post_text = preg_replace("/\[color=(\#[0-9A-Fa-f]{6}|[a-z\-]+):(\w){10}\]/si","[color=\\1]", $post_text);
    $post_text = preg_replace("/\[\/color:(\w){10}\]/si", "[/color]", $post_text);
    // list
    $post_text = preg_replace("/\[\/list:(\w):(\w){10}\]/si", "[/list]", $post_text);
	$post_text = preg_replace("/\[list=\]/si","[list]", $post_text);
	$post_text = preg_replace("/\[list:(\w{10})\]/si","[list]", $post_text);
	$post_text = preg_replace("/\[list=(.*?):(\w{10})\]/si","[list=\\1]", $post_text);
	$post_text = preg_replace_callback("/\[list=(.*?)\](.*?)\[\/list]/si","orderedList", $post_text);
	$post_text = preg_replace_callback("/\[list\](.*?)\[\/list]/si","unorderedList", $post_text);

    // code
	$post_text = preg_replace("/\[code:(\w):(\w){10}\]/si","[code]", $post_text);
    $post_text = preg_replace("/\[\/code:(\w):(\w){10}\]/si", "[/code]", $post_text);
    // don't use the following form.  It will not work with double
    // embeded bbcode.  Example:  A quote that has been quoted.
    //	$post_text = preg_replace("/\[b:(\w){10}\](.*?)\[\/b:(\w){10}\]/si", "[b]\\2[/b]", $post_text);

    if ($enableSig) {
        $post_text .= '[addsig]';
    }
    return $post_text;
}
function orderedList($matches)
{
    $listItems = $matches[2];
    $listItems = '[*]' . $listItems;
    $listItems = preg_replace("/(\\n)/si","\n[*]",$listItems);
    $listItems = rtrim($listItems,"\n[*]");
    $post_text = '[list=' . $matches[1] . ']' . $listItems . '[/list]';
    return $post_text;
}
function unorderedList($matches)
{
    $listItems = $matches[1];
    $listItems = '[*]' . $listItems;
    $listItems = preg_replace("/(\\n)/si","\n[*]",$listItems);
    $listItems = rtrim($listItems,"\n[*]");
    $post_text = '[list]' . $listItems . '[/list]';
    return $post_text;
}
function determineSize($matches)
{
    switch ($matches[1]) {
        case '7':
        $text = 'tiny';
        break;
        case '9':
        $text = 'small';
        break;
        case '12':
        $text = 'normal';
        break;
        case '18':
        $text = 'large';
        break;
        case '24':
        $text = 'huge';
        break;
    }

        return "[size=$text]";
}

/**
 * users
 *
 */
function convert_users()
{
    global $dbconn, $pntable, $prefix;
    echo "Users : ";
    flush();
    $fromuserstable = $prefix . "_users";
    $touserstable   = $pntable['pnforum_users'];
    $touserscolumn  = &$pntable['pnforum_users_column']; 
    $sql = "DELETE FROM $touserstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    $sql = "INSERT INTO $touserstable ( 
                $touserscolumn[user_id], 
                $touserscolumn[user_level], 
                $touserscolumn[user_posts], 
                $touserscolumn[user_rank] ) 
            SELECT " . $fromuserstable . ".user_id, 
                   " . $fromuserstable . ".user_level, 
                   " . $fromuserstable . ".user_posts, 
                   " . $fromuserstable . ".user_rank
            FROM $fromuserstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    echo $dbconn->Affected_Rows() . " users converted<br />";
    flush();
    return;
}

/**
 * users_extra
 *
 */
function convert_users_extra()
{
    // copy user_lastvisit, this needs our attention
    global $dbconn, $pntable, $prefix;
    $fromuserstable = $prefix . "_users";
    $touserstable   = $pntable['pnforum_users'];
    $touserscolumn  = &$pntable['pnforum_users_column']; 
    $sql = "SELECT " . $fromuserstable . ".user_id,
                   " . $fromuserstable . ".user_lastvisit 
            FROM $fromuserstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    $userarray = array();
    while(!$result->EOF) {
        $row = $result->GetRowAssoc(false);
        $d=getdate($row['user_lastvisit']); 
        $yr=$d["year"]; 
        $mo=$d["mon"]; 
        $da=$d["mday"]; 
        $hr=$d["hours"]; 
        $mi=$d["minutes"]; 
        $se=$d["seconds"]; 
        $userarray[$row['user_id']] = sprintf("%04d%02d%02d%02d%02d%02d",$yr,$mo,$da,$hr,$mi,$se);
        $result->MoveNext();
    }
    $result->Close();
    
    $usercount = 0;
    foreach($userarray as $user_id=>$user_lastvisit) {
        $sql2 = "UPDATE $touserstable
                 SET $touserscolumn[user_lastvisit] = '$user_lastvisit'
                WHERE $touserscolumn[user_id]=$user_id";
        $result2 = $dbconn->Execute($sql2);
        if ($dbconn->ErrorNo() != 0) {
        	die($dbconn->ErrorMsg() . " : $sql2");
        }
        $usercount++;
    }
    echo "$usercount lastvisit times converted<br />";
    flush();

    // anon user in pnphpbb is uid = -1 while it is 1 in PostNuke 
    $sql2 = "UPDATE $touserstable
             SET $touserscolumn[user_id] = 1
            WHERE $touserscolumn[user_id]=-1";
    $result2 = $dbconn->Execute($sql2);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql2");
    }
    echo "Anonymous User changed to userid 1<br />";
    flush();
    return;
}

/**
 * ranks
 *
 */
function convert_ranks()
{
    global $dbconn, $pntable, $prefix;
    echo "Ranks : ";
    flush();
    $fromrankstable = $prefix . "_ranks";
    $torankstable   = $pntable['pnforum_ranks'];
    $torankscolumn  = &$pntable['pnforum_ranks_column']; 
    $sql = "DELETE FROM $torankstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    $sql = "INSERT INTO $torankstable ( 
                $torankscolumn[rank_id], 
                $torankscolumn[rank_title], 
                $torankscolumn[rank_min], 
                $torankscolumn[rank_special], 
                $torankscolumn[rank_image] ) 
            SELECT " . $fromrankstable .".rank_id, 
                   " . $fromrankstable .".rank_title, 
                   " . $fromrankstable .".rank_min, 
                   " . $fromrankstable .".rank_special, 
                   " . $fromrankstable .".rank_image
            FROM $fromrankstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    echo $dbconn->Affected_Rows() . " ranks converted<br />";
    flush();
    return;
}

/**
 * topic_watch
 *
 */
function convert_topics_watch()
{
    global $dbconn, $pntable, $prefix;
    echo "Topic watch : ";
    flush();
    $fromwatchtable  = $prefix . "_topics_watch";
    $fromtopicstable = $prefix . "_topics";
    $tosubstable   = $pntable['pnforum_topic_subscription'];
    $tosubscolumn  = &$pntable['pnforum_topic_subscription_column']; 
    $sql = "DELETE FROM $tosubstable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    $sql = "INSERT INTO $tosubstable (
                $tosubscolumn[topic_id],
                $tosubscolumn[user_id],
                $tosubscolumn[forum_id])  
            SELECT w.topic_id,
                   w.user_id,
                   t.forum_id
            FROM $fromwatchtable as w,
                 $fromtopicstable as t
            WHERE w.topic_id = t.topic_id";
    
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    echo $dbconn->Affected_Rows() . " topic subscriptions converted<br />";
    flush();
    return;
}

function microtime_float()
{
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}

function getnumberofposts()
{
    global $dbconn, $pntable, $prefix;
    
    $frompoststable = $prefix . "_posts";
    $sql = "SELECT count(*) AS total 
            FROM $frompoststable";
    $result = $dbconn->Execute($sql);
    if ($dbconn->ErrorNo() != 0) {
    	die($dbconn->ErrorMsg() . " : $sql");
    }
    list ($total) = $result->fields;
    return $total;
}

function truncate_destination_tables()
{
    
}
?>
